#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include "tetX.h"
#include "keyjoy.h"
#include "egafont.h"
#include "kbcodes.h"

extern long Ticks;
extern int ScreenHeight, ScreenWidth, ScreenDepth, ScrollAvailable;
extern int ScrollY, ScrollEY, ScoreX, ScoreW;
extern int FgrColour, BkgrColour, TxtColour, HiliteColour, ScrollColour;
extern int JoyEnabled, MusicEnabled;
extern char *IntroText, *PlayListFileName, *PauseFileName, *ScoresFileName;
extern char *Player, FontFileName[], FontFileDir[];
extern char FillPats[][8];
extern WHERE_WE_ARE where;
extern char	 JoyName[];
extern int 	 JoyVersion;
extern short JoyNewDriver;
extern int   TimerSuspended;
extern int     wide_chars;
	
static int   PrologX, PrologY, PrologW, PrologH;
static int   PrologHeight;

#define PROLOG_WIDTH 23
#define DELAY_TICKS   1
extern IMAGE_HEADER Intelligent_Hdr, bottom_Hdr, tetris_Hdr;

//-------------------------------------------------------
static int GetPrologueRetval(void)
{    int c, retval;
     static unsigned long OldTicks;

 /*    if (ScrollAvailable && Ticks != OldTicks) */
#ifndef  SCROLLER_DISABLED
     if (Ticks != OldTicks)
     {   ScrollerTick();
         OldTicks = Ticks;
     }
#endif

     c = getKeyJoy();
     retval = -1;
     if (c < 0x100) c = toupper(c);

     switch(c)
     {  case KY_ENTER:
        case KY_SPACE:
        case KY_ESC:
        case JOY_BTN1:
            retval = 0;
            break;

        case 'Q':
            retval = 8;
            break;

        case 'C':
        case JOY_BTN2:
            retval = 6;
            break;

        case 'D':
            retval=4;
            break;

        case 'J':
            if (joySetParams() == 0)
                     JoyEnabled = 1;
             break;

        case 'M':
            if (PlayListFileName)
            { MusicEnabled = !MusicEnabled;
              PrepareMusic(0);
            }


      }

      return retval;
}

//-------------------------------------------------------
double GetCPUSpeed(void)
{
    char line[81];
    char *ptr;
    FILE *fd = fopen("/proc/cpuinfo", "r");

    if (!fd) return .0;

    while ((ptr = fgets(line, 80, fd)) != NULL)
      if (memcmp(line, "bogomips", 8) == 0) break;

    fclose(fd);

    if (!ptr) return .0;

    ptr = strchr(line, '\t');
    if (!ptr) return .0;

    return  strtod(ptr+3 , NULL);
}



int GetFreeMem(long *ram, long *swap)
{
    char line[81];

    FILE *fd = fopen("/proc/meminfo", "r");

    if (!fd) return 4;
    while (fgets(line, 80, fd) != NULL)
    { if (memcmp(line, "MemFree:", 8) == 0) *ram = atol(line + 9);
      else
      if (memcmp(line, "SwapFree:", 9) == 0) *swap = atol(line + 10);
    }

    fclose(fd);

    return 0;
}

void ShowConfigLine(char *line, int x, int y)

{   char left[13];
  //  line [PrologW/8-3] = '\0';

    memcpy(left, line, 12);
    left[12] = 0;

    egaShowText(left, x, y, 2, BkgrColour);
    if (strlen(line) > 12)
      egaShowText(line+12, x+egaGetTextWidth(left), y, TxtColour, BkgrColour);


}


void ShowConfig(void)
{   RECT rc;
    char *Header = "Configuration";
    char line[81], text[41];
    double mips;
    long ram, swap;
    int hscale = 2, vscale = 3;
//    char *ptr;
    int x, y, fh;
    int joy_stat;

    rc.top = PrologY; rc.bottom = PrologY + PrologH;
    rc.left = PrologX; rc.right = PrologX + PrologW;

    DrawSolidRect(&rc, BkgrColour);
    x = (PrologW - egaGetTextWidth(Header)*hscale) >> 1;
    x += PrologX;
    y = PrologY + 3;
    fh = egaGetFontHeight() + 3;
    if (ScreenHeight > 350) fh += 2;

    egaShowScaledText(Header, x, y, 12, 0, hscale, vscale);
    x = PrologX + 8;
    y += fh*vscale + 1; 

    sprintf (line, "Version:     %d.%d.%d",
               ITET_VERSION >> 16,
               (ITET_VERSION >> 8) & 255, ITET_VERSION &255);
    ShowConfigLine(line, x, y);
    y += fh;

    sprintf(line,  "Player name: %s", Player ? Player : "");
    ShowConfigLine(line, x, y);
    y += fh;


    mips = GetCPUSpeed();
    if (mips == .0) strcpy(text, "undefined");
    else
    {  char *pnt;
       sprintf(text, "%-10.2f ", mips);
       pnt = strchr(text, '.');
       if (pnt) *(pnt+2) = '\0';
       strcat(text, " bogoMIPS");
    }

#ifdef X11
    sprintf(line, "Window size: %dx%d %d bpp ",
#else
    sprintf(line, "Video mode:  G%dx%d %d bpp ",
#endif
                   ScreenWidth, ScreenHeight, ScreenDepth);
    ShowConfigLine(line, x, y);
    y += fh;

    sprintf(line, "CPU speed:   %s", text);
    ShowConfigLine(line, x, y);
    y += fh;

    if (! GetFreeMem(&ram, &swap))
    {
       sprintf(line, "Free memory: RAM - %ldK, SWAP = %ldk", ram, swap);
       ShowConfigLine(line, x, y);
       y += fh;

    }

    joy_stat = IsJoystickSupported(); 
    if (joy_stat)
    {  if (joy_stat > 1)
           snprintf(text, 41, "driver %d.%d [XInput]", 
			 JoyVersion >> 8, JoyVersion & 0xff);
       else
           snprintf(text, 41, "driver %d.%d.%d [Linux]", 
	     JoyVersion >> 16, (JoyVersion >> 8) & 0xff,
	     JoyVersion & 0xff);
	     
    
       sprintf (line, "Joystick:    %s, %s",
                JoyEnabled ? "enabled" : "disabled", text);

       if (joy_stat > 1 || JoyNewDriver)
        {  ShowConfigLine(line, x, y);
           y += fh;
           sprintf( line, "             %s", JoyName);
        }
    }
    else
    	 sprintf (line, "Joystick:    not supported");

    ShowConfigLine(line, x, y);
    y += fh;

    if (strlen(FontFileDir) > 0)
    { sprintf(line, "Font dir:    %s", FontFileDir);
      ShowConfigLine(line, x, y);
      y+=fh;
    }

    strcpy(text, wide_chars ? " [W]" : "");
    sprintf(line, "Font name:   %s%s", FontFileName, text);
    ShowConfigLine(line, x, y);
    y+=fh;

    sprintf(line, "Play list:   %s",  PlayListFileName ? PlayListFileName : "disabled");
    ShowConfigLine(line, x, y);
    y+=fh;

#ifndef X11
    sprintf(line, "Pause file:  %s",  PauseFileName ? PauseFileName : "disabled");
    ShowConfigLine(line, x, y);
    y+=fh;
#endif

    sprintf(line, "Scores file: %s", ScoresFileName);
    ShowConfigLine(line, x, y);
    y+=fh;

    ContextRectToScreen(&rc);
}


//-------------------------------------------------------
int ShowPrologue(void)
{
      typedef struct
      { int  pat, rot;
        int  x, y;
      } DEMOPAT;

      int i, ind, from, to;
      int y1, x2, y2, offy;
      int wid, hei;
      int froms[3];
      long  NextTicks;

      int retval = 0;

      FIGURE    figure;
      DEMOPAT  *CurDemo;
      RECT  rc, rc1;

      static  int PatLevels[3] = {6, 4, 7};
      static  int PatOff[3] = {2, 2, 0 };

      static DEMOPAT  DemoPats[] =
      { {0, 1,  1, 0}, { 2, 2,  4, 2}, { 0, 1, 9,  0}, {2, 3, 12, 1},
        {6, 1, 14, 1}, { 4, 2, 20, 2},

        {4, 0,  4, 0}, {0, 1, 17, 0}, {0, 1, 18, 0}, {2, 0,  20, 0},

        {3, 0,  0, 0}, { 4, 0, 4,  0}, {3, 0, 8, 0}, {2, 3, 12, 0},
        {4, 1, 14, 0},  { 1, 0, 16, 0}, { 4, 0, 20, 0}
      };

      static char *Botmes = "by Abandoned Computer Enthusiast" ;

#define  FALL_SPEED 1

    char  DummyFig[FALL_SPEED][FIG_DIM];

// static int joypresskeys[3] = {'H', Enter, 'J'};
    where = W_PROLOGUE;

    // Initialize dummy figure with zeroes
    for (i=0; i<FALL_SPEED; i++)
             memset(DummyFig[i], 0, FIG_DIM);

 // if (SoundType & SOUND_MUSIC)
 //          music_play_melody(&DemoMel);
     PrologHeight = ScreenHeight > 350 ? 20 : 18;

     PrologW = PROLOG_WIDTH * FIG_WIDTH;
     PrologH = PrologHeight * FIG_HEIGHT;

     PrologX = (ScreenWidth - PrologW) >> 1;

/*     if(ScrollAvailable)
        ScrollAvailable = (SetScrollerParam(PrologW) == 0);

     if (ScrollAvailable)
        PrologY = ScrollY - PrologH - 30; // (ScreenHeight - PrologH) >> 1;
     else
        PrologY = (ScreenHeight - PrologH) >> 1;
*/
#ifdef SCROLLER_DISABLED
        PrologY = (ScreenHeight - PrologH) >> 1;
#else
        SetScrollerParam(PrologW);
        PrologY = ScrollY - PrologH - 30;
#endif


     PrepareMusic(0);
     AllocScreenContext();
     ScreenToScreenContext();

     rc.top = 0; rc.bottom = ScreenHeight;
     rc.left = 0; rc.right = ScreenWidth;
     FgrColour = 5;
     DrawPatRect(&rc, FillPats[11], 0);

     rc.top = PrologY; rc.bottom = PrologY + PrologH;
     rc.left = PrologX; rc.right = PrologX + PrologW;

     DrawFramedRect(&rc);
     ScreenContextToScreen();

     rc1.left = PrologX;
     rc1.right = PrologX + PrologW;

     // Separated from next loop to cope twith pressing 'C'
     from = 0;
     for (ind =0; ind<3; ind++)
     {    froms[ind] = from;
          from += PatLevels[ind];
     }

     for (ind = 0, from = 0; ind < 3; ind++)
     { //   froms[ind] = from;
          to = from + PatLevels[ind];
          NextTicks = Ticks;


          for (y1 = 0; y1 < PrologHeight + PatOff[ind] -  5 ; y1+=FALL_SPEED)
          {
             NextTicks += DELAY_TICKS;


             for (i=from; i<to; i++)
             {
               CurDemo = DemoPats + i;
               get_figure(figure, CurDemo->pat, CurDemo->rot);

               wid = fig_width(figure);
               hei = fig_height(figure);

               x2 = CurDemo->x * FIG_WIDTH  + PrologX;
               y2 = (CurDemo->y + y1) * FIG_HEIGHT + PrologY;

               if (y1>0) ShowFigure      /* clear lines */
                   (DummyFig, x2, y2-FALL_SPEED*FIG_HEIGHT, wid, FALL_SPEED);

                                          /* empty string */

               ShowFigure(figure, x2, y2, wid, hei);

             } // for i

             offy = y1 - FALL_SPEED;
             if (offy < 0) offy = 0;
             rc1.top = offy * FIG_HEIGHT + PrologY;
             rc1.bottom = (y1+FIG_DIM) *FIG_HEIGHT + PrologY;
             ContextRectToScreen(&rc1);

             while (Ticks < NextTicks && !TimerSuspended)
             {  retval = GetPrologueRetval();
                if (retval == 6) goto Part2;
                if (retval >= 0) goto GoOut;
		pause();
	    //            if (retval != 6 && retval >= 0) goto GoOut;
             } // while
           }

          from = to;
      }


      // Part II
 Part2:
     DrawFramedRect(&rc);


     y1 = PrologHeight-10;
     NextTicks = Ticks;
     for (; y1>=(PrologHeight-6)>>1; y1-=FALL_SPEED)
     {   NextTicks += DELAY_TICKS;
         for (ind = 2; ind >=0; ind--)
         {   from = froms[ind];
             to = from + PatLevels[ind];
             offy = PatOff[ind];

             for (i=from; i<to; i++)
             {

               CurDemo = DemoPats + i;
               get_figure(figure, CurDemo->pat, CurDemo->rot);

               wid = fig_width(figure);
               hei = fig_height(figure);

               x2 = CurDemo->x * FIG_WIDTH  + PrologX;
               y2 = (CurDemo->y + y1+offy)*FIG_HEIGHT + PrologY;

               ShowFigure      /* clear lines */
                   (DummyFig, x2, y2+FIG_HEIGHT*hei, wid, FALL_SPEED);

                                /* Show current figure */
               ShowFigure(figure, x2, y2, wid, hei);

              }

         }

         rc1.top = y1 * FIG_HEIGHT + PrologY;
         offy = (y1 + FIG_DIM*3 + FALL_SPEED) * FIG_HEIGHT;
         if (offy > PrologH) offy = PrologH;
         rc1.bottom = offy + PrologY;
         ContextRectToScreen(&rc1);


         while (Ticks < NextTicks && !TimerSuspended)
         {  retval = GetPrologueRetval();
            if (retval >= 0) goto GoOut;
	    pause();
	 } // while

     }

 //    y2 = PrologY + y1*FIG_HEIGHT - 40;
 //    x2 = PrologX;
     y2 = PrologY + y1*FIG_HEIGHT - 30;
     x2 = PrologX-16;
    showImage(&Intelligent_Hdr, x2, y2, 0);


     TxtColour = 14;
     i = egaGetFontHeight();

     y2 = PrologY + (y1 + FIG_DIM*2) * FIG_HEIGHT-20;
     y1 = egaGetTextWidth(Botmes);
     //x2 = ((PrologW-y1) >> 1)  + PrologX;
     x2 = PrologX + PrologW - y1;

 //    egaShowScaledText(Botmes, x2, y2, HiliteColour, BkgrColour, 1, 1);
     egaShowText(Botmes, x2, y2, 14, 0);

     x2 = PrologX;
     y2 = PrologY + PrologH - 54;
     showImage(&bottom_Hdr, x2, y2, 0);

     rc1.top = PrologY;  rc1.bottom = PrologY + PrologH;
     rc1.left = PrologX;  rc1.right = PrologX + PrologW;
     ContextRectToScreen(&rc1);

     DeleteScreenContext();

#ifndef SCROLLER_DISABLED
/*     if (ScrollAvailable)
         ScrollAvailable = (StartScroller(IntroText, 1, 0, NULL) == 0);
*/
       StartScroller(IntroText, 1, 0, NULL);
#endif

     NextTicks = Ticks + 364;

     y1 = 0;
     while ((Ticks < NextTicks || IsScrollerActive()) && !TimerSuspended)
     {  retval = GetPrologueRetval();
        if (y1 == 0 && (retval == 6 || Ticks > NextTicks))
        {   ShowConfig(); y1 = 1; }
        else
        if (retval >= 0) goto GoOut;
	pause();
     } // while

     retval = 0;

GoOut:
//  Either of the following two commands may be idle,
//  without unpsetting the execution
     DeleteScreenContext();
#ifndef SCROLLER_SDISABLED
     StopScroller();
#endif
     return retval;

}

